Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Label4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label4.Click

    End Sub

    Private Sub CheckAcctCredits_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckAcctCredits.Click
        ' create webservice instance
        Dim ASPSMSX As com.aspsms.webservice.ASPSMSSOAPWebService = New com.aspsms.webservice.ASPSMSSOAPWebService
        Dim Result As Single
        ' invoke CheckCredits method
        Result = ASPSMSX.CheckCredits(ASPSMSUserKey.Text, ASPSMSPassword.Text)
        ' display result
        If Result > 0 Then
            MsgBox("You have " & Result & " credits left on your ASPSMS.COM account", MsgBoxStyle.Information)
        Else
            MsgBox("The specified account doesn't exist, the password is invalid, or the account doesn't have any credits left.", MsgBoxStyle.Exclamation)
        End If
        ' destroy webservice instance
        ASPSMSX.Dispose()
    End Sub

    Private Sub SendMessage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SendMessage.Click
        ' create webservice instance
        Dim ASPSMSX As com.aspsms.webservice.ASPSMSSOAPWebService = New com.aspsms.webservice.ASPSMSSOAPWebService
        ' invoke SimpleTextSMS method
        If ASPSMSX.SimpleTextSMS(ASPSMSUserKey.Text, ASPSMSPassword.Text, Subscriber.Text, Originator.Text, MessageText.Text) Then
            ' returned true; call was successful
            MsgBox("SMS successfully sent.", MsgBoxStyle.Information)
        Else
            ' returned false; some error occured
            MsgBox("The SMS could not be sent. Make sure the supplied credentials are valid.", MsgBoxStyle.Exclamation)
        End If
        ' destroy webservice instance
        ASPSMSX.Dispose()
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbOperation.SelectedIndexChanged

    End Sub

    Private Sub ExecuteOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExecuteOP.Click
        ' create web service instance
        Dim ASPSMSX As com.aspsms.webservice.ASPSMSSOAPWebService = New com.aspsms.webservice.ASPSMSSOAPWebService
        ' create SMSX object instance
        Dim SMSXObj As New com.aspsms.webservice.cASPSMSX

        ' This step is optional (retrieve SMSX object with default values)
        'SMSXObj = ASPSMSX.GetASPSMSXObj

        ' apply user specific settings
        With SMSXObj
            .UserKey = ASPSMSUserKey.Text
            .Password = ASPSMSPassword.Text
            .Originator = ExtendedOriginator.Text
            .DeferredDeliveryTime = DeferredDeliveryTime.Text
            .TimeZone = txtTimeZone.Text
            .FlashingSMS = FlashingSMS.Checked
            .BlinkingSMS = BlinkingSMS.Checked
            .MessageData = MessageData.Text
            .MMC = Val(MMC.Text)
            .MNC = Val(MNC.Text)
            .XSer = XSer.Text
            .Recipients = GetSubscriberListString()
            .TRNsForNotificationInquiry = GetTRNListString()
            .OriginatorUnlockCode = txtUnlockCode.Text
            ' set operation
            .Operation = GetSelectedOperation()
        End With
        ' call PutASPSMSXObj method and retrieve result
        Dim OpResult As com.aspsms.webservice.cResult
        OpResult = ASPSMSX.PutASPSMSXObj(SMSXObj)
        ' display errorcode/description and additional data
        MsgBox("Result ErrorCode: " & OpResult.ErrorCode & ", ErrorDescription: " & OpResult.ErrorDescription & ", AdditionalData: " & OpResult.AdditionalData)
        Debug.Print("ErrorCode: " & OpResult.ErrorCode)
        Debug.Print("ErrorDescription: " & OpResult.ErrorDescription)
        Debug.Print("Additional Data:" & OpResult.AdditionalData)
        ' dispose service instance
        ASPSMSX.Dispose()
    End Sub

    Private Sub AddSubscriber_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddSubscriber.Click
        Dim RcptTrnPair As String : Dim SplitPos As Integer
        Dim NewItem As ListViewItem
        Dim Rcpt As String : Dim Trn As String
        RcptTrnPair = InputBox("Enter recipient number (rcptnr[,trn])?", "ASPSMSXDemo", "")
        If Not RcptTrnPair = "" Then
            SplitPos = InStr(RcptTrnPair, ",")
            If SplitPos > 0 Then
                Rcpt = Microsoft.VisualBasic.Left(RcptTrnPair, SplitPos - 1)
                Trn = Microsoft.VisualBasic.Mid(RcptTrnPair, SplitPos + 1)
                NewItem = lsvRecipients.Items.Add(Rcpt)
                NewItem.SubItems.Add(Trn)
            Else
                lsvRecipients.Items.Add(RcptTrnPair)
            End If
        End If
    End Sub

    Private Function GetSubscriberListString() As String
        Dim X As ListViewItem : Dim SList As String = ""
        For Each X In lsvRecipients.Items
            SList = SList & X.Text
            If X.SubItems.Count = 2 Then
                SList = SList & "," & X.SubItems(1).Text
            End If
            SList = SList & ";"
        Next
        GetSubscriberListString = SList
    End Function

    Private Function GetTRNListString() As String
        Dim X As String : Dim SList As String = ""
        For Each X In lsbTRNs.Items
            SList = SList & X & ","
        Next
        SList = Microsoft.VisualBasic.Left(SList, Len(SList) - 1)
        GetTRNListString = SList
    End Function

    Private Function GetSelectedOperation() As com.aspsms.webservice.ASPSMSX_Operation
        Dim Op As com.aspsms.webservice.ASPSMSX_Operation
        Select Case cmbOperation.Text
            Case "OP_TextSMS"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_TextSMS
            Case "OP_PictureMessage"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_PictureMessage
            Case "OP_Logo"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_Logo
            Case "OP_GroupLogo"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_GroupLogo
            Case "OP_Ringtone"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_Ringtone
            Case "OP_VCard"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_VCard
            Case "OP_BinaryData"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_BinaryData
            Case "OP_MessageWaitingIndication"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_MessageWaitingIndication
            Case "OP_RandomLogo"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_RandomLogo
            Case "OP_InquireDeliveryNotifications"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_Ringtone
            Case "OP_CheckOriginatorAuthorization"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_CheckOriginatorAuthorization
            Case "OP_SendOriginatorUnlockCode"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_SendOriginatorUnlockCode
            Case "OP_UnlockOriginator"
                Op = com.aspsms.webservice.ASPSMSX_Operation.OP_UnlockOriginator
        End Select
        GetSelectedOperation = Op
    End Function

    Private Sub RemoveSubscriber_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveSubscriber.Click
        Dim x As ListViewItem
        For Each x In lsvRecipients.SelectedItems
            lsvRecipients.Items.Remove(x)
        Next
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        lsbTRNs.Items.Clear()
    End Sub

    Private Sub btnCopyTRNs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopyTRNs.Click
        Dim x As ListViewItem
        For Each x In lsvRecipients.Items
            If Not x.SubItems(1).Text = "" Then lsbTRNs.Items.Add(x.SubItems(1).Text)
        Next
    End Sub

    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim NewTRN As String
        NewTRN = InputBox("Enter transaction reference number ?", "ASPSMSXDemo", "")
        If Not NewTRN = "" Then lsbTRNs.Items.Add(NewTRN)
    End Sub
End Class
